<script>
	import Modal from "@/components/Modal.svelte"
	import Form from "@/components/Order/Form.svelte"
	import SVG from "@/components/svg.svelte"
	import Button from "@/components/button.svelte"
	import BrandsSelector from "@/components/Form/BrandsSelector.svelte"

	import { isLight } from "@/stores/static"
	import { submit, data, pending, success } from "@/stores/form"
	import { modal } from "@/stores"
	import { t } from "@/i18n"

	let brandsSelector = false

	modal.subscribe(v => {
		if (!v) {
			$data.service = ""
			$data.serviceName = ""
			brandsSelector = false
		}
	})
</script>

<template lang="pug">
Modal( let:close='{close}' on:close!='{() => modal.set(false)}' bind:active='{$modal}' success='{$success}' )
	+if('!$success')
		.order-form( class:hidden='{brandsSelector}' )
			.top.is-flex.is-align-items-center.is-justify-content-space-between
				p {$data.serviceName ? $t(`services.${$data.serviceName}.title`) : $t("buttons.order_car")}
			.body: Form
				svelte:fragment( slot="prepend" )
					.field: Button( on:click!='{() => brandsSelector = true}' type="input" align="justify" fullwidth )
						span.icon( slot="icon-right" ): SVG( folder="icons" name="angle-right" )
						.is-flex.is-align-items-center.is-justify-content-flex-start
							+if('$data.brand')
								span.icon.brand.is-flex.is-align-items-center.is-justify-content-center: SVG( folder="brands" name='{$data.brand.url}' )
							|{$data.brand?.name || $t("buttons.select_brand")}
			.bottom: Button( on:click='{submit}' align="left" fullwidth loading='{$pending}' )
				span.icon( slot="icon-right" ): SVG( folder="icons" name="arrow-right" )
				|{$t("buttons.order_car")}
		.brands-selector( 
			class:active='{brandsSelector}'
			class:dark='{!$isLight}' )
			.top.is-flex.is-align-items-center.is-justify-content-space-between
				p.is-flex.is-align-items-center.is-justify-content-center
					span.icon.is-flex( on:click!='{() => brandsSelector = false}' ): SVG( folder="icons" name="angle-left" )
					|{$t("buttons.select_brand")}
			.body: BrandsSelector( bind:value='{$data.brand}' on:close!='{() => brandsSelector = false}' )
		.close.icon.is-flex( on:click!='{close}' ): SVG( folder="icons" name="xmark" )
		+else
			.thanks
				.is-flex.is-flex-direction-column.is-align-items-center.is-justify-content-flex-start
					.icon.success.is-flex.is-align-items-center: SVG( name="success" )
					p {$t("form.thanks")}
				.bottom
					Button( on:click='{close}' align="left" fullwidth )
						span.icon( slot="icon-right" ): SVG( folder="icons" name="xmark" )
						|{$t("buttons.close")}
</template>

<style lang="scss">	
.order-form {
	position: relative;
	z-index: 1;
	transition: scale .2s ease-in-out;
	&.hidden {
		scale: .9;
	}
}

.top .icon,
.icon.close {
	cursor: pointer;
	:global(svg path) {
		fill: $primary;
	}
}

.close {
	width: 1.5rem;
	position: absolute;
	top: 1.5rem;
	right: 1.5rem;
	z-index: 2;
}

.top {
	padding-right: 1.5rem;
	p {
		font-size: 1.125rem;
		font-weight: 500;
		text-transform: uppercase;
		color: $primary;
	}
	.icon {
		&+span {
			margin-left: .5rem;
		}
	}
}

.icon.brand {
	width: 1.5rem;
	height: 1.5rem;
	margin-right: .5rem;
	:global(svg) {
		height: 1.5rem;
	}
}

.order-form .body {
	max-width: 310px;
	width: 100%;
	margin: 0 auto;
	padding: 2rem 0;
}

.brands-selector {
	padding: 1.5rem;
	background: $dark;
	width: 100%;
	height: calc(100% - 2rem);
	position: absolute;
	top: 2px;
	left: 100%;
	z-index: 2;
	transition: 
		left .2s ease-in-out,
		background .2s ease-in-out;
	&.dark {
		background: #333333;
		.top {
			background: #333333;
		}
		:global(.checked svg path) {
			fill: #333333;
		}
	}
	&.active {
		left: 0;
	}
	.top {
		width: calc(100% - 3rem);
		background: $dark;
		position: sticky;
		top: 0;
		left: 0;
		transition: background .2s ease-in-out;
		p .icon {
			width: 1.5rem;
			margin-right: .5rem;
		}
	}
	.body {
		height: inherit;
		margin-top: 2rem;
		overflow: auto;
		scrollbar-color: $gray-dark transparent;
		scrollbar-width: thin;

		&::-webkit-scrollbar {
			width: 4px;
		}

		&::-webkit-scrollbar-track {
			background: $black;
			border-radius: 24px;
		}

		&::-webkit-scrollbar-thumb {
			background: $gray-text;
			border-radius: 24px;
			cursor: pointer;
		}

		&::-webkit-scrollbar-thumb:hover {
			background: $gray-text;
		}
	}
}
</style>